﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.3
@EndOfDesignText@
#Event: Tick()
#Event: TypewriterDone()
#Event: ScrollDone()

Sub Class_Globals
	Type FontInfo(Name As String, Font As Typeface)
	Type TextInfo(Text As String, Font As Typeface, FontID As Int, Bold As Boolean, Italic As Boolean, Underline As Boolean, BGColor As Int, Color As Int, Size As Int, Align As Int, TagID As Int, Length As Int, Width As Int, Height As Int, LineHeight As Int, Speed As Int, DATA As Map)
	Type ImageInfo(BMP As Bitmap, Name As String)
	Type CSSinfo(Selectors As List, Data As Map, Filename As String)
	
	Private Fonts As List, Images As List, TheDefaultFont As String, TheDefaultFontSize As Int, TheDefaultFontColor As Int, TheDefaultAlignment As Int, ParsedHTML As List, SavedHTML As String
	Public DefaultBold As Boolean, DefaultItalic As Boolean, DefaultUnderline As Boolean, DefaultAlpha As Int, TypeWriterLength As Int, TypeWriterSpeed As Int, StartY As Int, BackgroundColor As Int, ScrollSpeed As Int
	
	Private TAG_HTML As Byte = 0, TAG_Closing As Byte = -1, TAG_IMG As Byte = -2, TAG_CRLF As Byte = -3, TAG_CRLF_Natural As Byte = -4
	Private FailedOn As Int, TotalLength As Int, LineHeight As Int, WasSplit As Int, Background As Bitmap, CSS As List, AnonymousCSS As Int, vbQuote As String = Chr(34)
	Private BG As Canvas, Ticker As Timer, DestinationRect As Rect, ModuleName As Object, EventName As String, Frame As Int, TotalHeight As Int
End Sub

public Sub InitializeCanvas(Destination As Canvas)
	BG = Destination
End Sub

public Sub InitializeCSS
	CSS.Initialize
	AnonymousCSS = 0
End Sub 
public Sub UnloadCSS(Filename As String)
	Dim temp As Long, CSSi As CSSinfo
	Filename = Filename.ToLowerCase
	For temp = CSS.Size-1 To 0 Step - 1 
		CSSi = CSS.Get(temp) 
		If Filename = CSSi.Filename Then CSS.RemoveAt(temp)
	Next
End Sub

Public Sub Initialize(Destination As Canvas)
	BG = Destination
	Fonts.Initialize
	Images.Initialize
	InitializeCSS
	TheDefaultFont = "default"
	TheDefaultFontColor = Colors.Black
	TheDefaultFontSize = 10
	TheDefaultAlignment = 1
	DefaultAlpha = 255
	TypeWriterSpeed = 1
	BackgroundColor = Colors.Transparent
	ClearHTML
End Sub
public Sub InitializeEvent(Module As Object, Name As String)
	ModuleName = Module
	EventName = Name
End Sub
private Sub EventInitialized As Boolean 
	Return EventName.Length > 0
End Sub


public Sub setDestination(X As Int, Y As Int, Width As Int, Height As Int)
	DestinationRect = SetRect(X,Y,Width,Height)
End Sub
public Sub getDestinationRect As Rect 
	Return DestinationRect
End Sub

public Sub InitializeTimer(Milliseconds As Int)
	Ticker.Initialize("Timer", Milliseconds)
	Ticker.Enabled = True 
End Sub
public Sub setTimerEnabled(Value As Boolean)
	Ticker.Enabled = Value 
End Sub
public Sub getTimerEnabled As Boolean
	Return Ticker.Enabled
End Sub
public Sub setTimerInterval(Milliseconds As Int)
	Ticker.Interval = Milliseconds
End Sub
public Sub getTimerInterval As Int
	Return Ticker.Interval
End Sub
private Sub Timer_Tick
	IncrementTimer
	DrawHTML
	RaiseEvent("Tick")
End Sub

private Sub RaiseEvent(Name As String)
	If EventInitialized Then 
		Name = EventName & "_" & Name
		If SubExists(ModuleName, Name) Then CallSubDelayed(ModuleName, Name)
	End If
End Sub

public Sub ClearHTML
	ParsedHTML.Initialize
	SavedHTML = ""
	FailedOn = -1
	TypeWriterLength = -1
	ParsedHTML.Initialize
	TotalLength = 0
	LineHeight = 0
	StartY = 0
	WasSplit = -1 
	ScrollSpeed = 0 
	Frame = -1
End Sub

public Sub setBackground(BMP As Bitmap)
	Background=BMP 
End Sub
public Sub getBackground As Bitmap
	Return Background
End Sub

'Use to draw a background over the previous image frame
public Sub SampleBackground() As Boolean 
	Dim BG2 As Canvas
	If DestinationRect.IsInitialized Then 
		Background.InitializeMutable(DestinationRect.Width,DestinationRect.Height)
		BG2.Initialize2(Background)
		BG2.DrawBitmap(BG.Bitmap, DestinationRect, SetRect(0,0, DestinationRect.Width,DestinationRect.Height))
		Return True 
	End If 
	Return False 
End Sub
public Sub ClearBackground
	Dim BMP As Bitmap
	Background = BMP 
End Sub

public Sub setDefaultFont(Name As String)
	TheDefaultFont = Name 
End Sub
public Sub getDefaultFont As String 
	Return TheDefaultFont
End Sub

public Sub setHTML(HTML As String)
	SavedHTML = HTML 
	ParsedHTML = ParseHTML(HTML)
	TotalLength = MaxLength
	Frame = 0
	UnloadCSS("anonymous")
	AnonymousCSS = 0
End Sub
public Sub getHTML As String 
	Return SavedHTML
End Sub

public Sub getLastErrorIndex As Int
	Return FailedOn
End Sub

'Index: -1=Debug All Indexes (requires you to have parsed HTML using setHTML), -2=get size of parsed HTML
public Sub DebugHTML(Index As Int) As String 
	Dim tempstr As StringBuilder, temp As Int, Info As TextInfo
	If Index = -2 Then Return ParsedHTML.Size
	tempstr.Initialize
	If Not(ParsedHTML.IsInitialized) Then Return "[NOT INIT]"
	If ParsedHTML.Size= 0 Then Return "[EMPTY]"
	If Index = -1 Then 
		For temp = 0 To ParsedHTML.Size-1 
			If temp > 0 Then tempstr.Append(CRLF)
			tempstr.Append(temp & ": " & DebugHTML(temp))
		Next 
	Else 
		Info = ParsedHTML.Get(Index)
		If Info.Align>0 Then'is text 
			tempstr.Append("<FONT FACE=""" & GetFontName(Info.FontID) & """ COLOR=""" & MakeHTMLColor(Info.Color) & """ ALIGN=""" & Info.Align & """ SIZE=""" & Info.Size & """")
			If Info.Bold Then tempstr.Append(" BOLD")
			If Info.Italic Then tempstr.Append(" ITALIC")
			If Info.Underline Then tempstr.Append(" UNDERLINE")
			tempstr.Append(">" & Info.Text & "</FONT>")
		Else 
			Select Case Info.Align
				Case TAG_IMG: 	Return "<IMG SRC=""" & Info.Text & """>"
				Case TAG_CRLF, TAG_CRLF_Natural: 	Return "<BR>"
			End Select
		End If
	End If
	Return tempstr.ToString
End Sub

'Alignment matches that of the number pad on your keyboard
'1=bottom left, 2=bottom center, 3=bottom right, 4=middle left, 5=middle center, 6=middle right, 7=top left, 8=top center, 9=top right
public Sub setDefaultAlignment(Value As Int)
	If Value < 1 Then Value = 1
	If Value > 9 Then Value = 9
	TheDefaultAlignment = Value 
End Sub
public Sub getDefaultAlignment As Int 
	Return TheDefaultAlignment
End Sub

public Sub setDefaultHTMLColor(Color As String, Alpha As Int) As Int 
	TheDefaultFontColor = HTMLColor(Color, Alpha)
	Return TheDefaultFontColor
End Sub
public Sub setDefaultFontColor(Color As Int)
	TheDefaultFontColor = Color
End Sub
public Sub getDefaultFontColor As Int
	Return TheDefaultFontColor
End Sub
public Sub HTMLColor(Color As String, Alpha As Int) As Int 
	Dim R As Int, G As Int, B As Int, tempstr() As String 
	Color = CleanName(Color)
	If Color.StartsWith("rgb") Or Color.StartsWith("argb") Then 
		If Color.Contains("(") And Color.Contains(")") Then 
			tempstr = Regex.Split(",", GetBetween(Color, "(", ")"))
			If tempstr.Length > 2 Then'argb(0=A,1=R,2=G,3=B) length=4, rgb(0=R,1=G,2=B) length=3
				For R = 0 To tempstr.Length-1
				 	tempstr(R) = tempstr(R).Trim
					If Not(IsNumber(tempstr(R))) Then Return TheDefaultFontColor
				Next 
				R = tempstr( tempstr.Length - 3 )
				G = tempstr( tempstr.Length - 2 )
				B = tempstr( tempstr.Length - 1 )
				If tempstr.Length = 4 Then Alpha = tempstr(0)
				Return Colors.ARGB(Alpha,R,G,B)
			End If 
		End If 
	End If
	If Not(Color.StartsWith("#")) Then 
		Select Case CleanName(Color).Replace(" ", "")
			'Red HTML Color Names
			Case "indianred": 				Color = "#CD5C5C"
			Case "lightcoral": 				Color = "#F08080"
			Case "salmon": 					Color = "#FA8072"
			Case "darksalmon": 				Color = "#E9967A"
			Case "lightsalmon": 			Color = "#FFA07A"
			Case "crimson": 				Color = "#DC143C"
			Case "red": 					Color = "#FF0000"
			Case "firebrick": 				Color = "#B22222"
			Case "darkred":					Color = "#8B0000"
			'Pink HTML Color Names
			Case "pink":					Color = "#FFC0CB"
			Case "lightpink":				Color = "#FFB6C1"
			Case "hotpink":					Color = "#FF69B4"
			Case "deeppink": 				Color = "#FF1493"
			Case "mediumvioletred": 		Color = "#C71585"
			Case "palevioletred":			Color = "#DB7093"
			'Orange HTML Color Names
			Case "lightsalmon": 			Color = "#FFA07A"
			Case "coral": 					Color = "#FF7F50"
			Case "tomato": 					Color = "#FF6347"
			Case "orangered": 				Color = "#FF4500"
			Case "darkorange": 				Color = "#FF8C00"
			Case "orange": 					Color = "#FFA500"
			'Yellow HTML Color Names
			Case "gold": 					Color = "#FFD700"
			Case "yellow": 					Color = "#FFFF00"
			Case "lightyellow": 			Color = "#FFFFE0"
			Case "lemonchiffon": 			Color = "#FFFACD"
			Case "lightgoldenrodyellow":	Color = "#FAFAD2"
			Case "papayawhip": 				Color = "#FFEFD5"
			Case "moccasin": 				Color = "#FFE4B5"
			Case "peachpuff": 				Color = "#FFDAB9"
			Case "palegoldenrod": 			Color = "#EEE8AA"
			Case "khaki": 					Color = "#F0E68C"
			Case "darkkhaki": 				Color = "#BDB76B"
			'Purple HTML Color Names
			Case "lavender": 				Color = "#E6E6FA"
			Case "thistle": 				Color = "#D8BFD8"
			Case "plum": 					Color = "#DDA0DD"
			Case "violet": 					Color = "#EE82EE"
			Case "orchid": 					Color = "#DA70D6"
			Case "fuchsia": 				Color = "#FF00FF"
			Case "magenta": 				Color = "#FF00FF"
			Case "mediumorchid": 			Color = "#BA55D3"
			Case "mediumpurple": 			Color = "#9370DB"
			Case "rebeccapurple": 			Color = "#663399"
			Case "blueviolet": 				Color = "#8A2BE2"
			Case "darkviolet": 				Color = "#9400D3"
			Case "darkorchid": 				Color = "#9932CC"
			Case "darkmagenta": 			Color = "#8B008B"
			Case "purple": 					Color = "#800080"
			Case "indigo": 					Color = "#4B0082"
			Case "slateblue": 				Color = "#6A5ACD"
			Case "darkslateblue": 			Color = "#483D8B"
			Case "mediumslateblue": 		Color = "#7B68EE"
			'Green HTML Color Names
			Case "greenyellow": 			Color = "#ADFF2F"
			Case "chartreuse": 				Color = "#7FFF00"
			Case "lawngreen": 				Color = "#7CFC00"
			Case "lime": 					Color = "#00FF00"
			Case "limegreen": 				Color = "#32CD32"
			Case "palegreen": 				Color = "#98FB98"
			Case "lightgreen": 				Color = "#90EE90"
			Case "mediumspringgreen": 		Color = "#00FA9A"
			Case "springgreen": 			Color = "#00FF7F"
			Case "mediumseagreen": 			Color = "#3CB371"
			Case "seagreen": 				Color = "#2E8B57"
			Case "forestgreen": 			Color = "#228B22"
			Case "green": 					Color = "#008000"
			Case "darkgreen": 				Color = "#006400"
			Case "yellowgreen": 			Color = "#9ACD32"
			Case "olivedrab": 				Color = "#6B8E23"
			Case "olive": 					Color = "#808000"
			Case "darkolivegreen": 			Color = "#556B2F"
			Case "mediumaquamarine": 		Color = "#66CDAA"
			Case "darkseagreen": 			Color = "#8FBC8B"
			Case "lightseagreen": 			Color = "#20B2AA"
			Case "darkcyan": 				Color = "#008B8B"
			Case "teal": 					Color = "#008080"
			'Blue HTML Color Names
			Case "aqua": 					Color = "#00FFFF"
			Case "cyan": 					Color = "#00FFFF"
			Case "lightcyan": 				Color = "#E0FFFF"
			Case "paleturquoise": 			Color = "#AFEEEE"
			Case "aquamarine": 				Color = "#7FFFD4"
			Case "turquoise": 				Color = "#40E0D0"
			Case "mediumturquoise": 		Color = "#48D1CC"
			Case "darkturquoise": 			Color = "#00CED1"
			Case "cadetblue": 				Color = "#5F9EA0"
			Case "steelblue": 				Color = "#4682B4"
			Case "lightsteelblue": 			Color = "#B0C4DE"
			Case "powderblue": 				Color = "#B0E0E6"
			Case "lightblue": 				Color = "#ADD8E6"
			Case "skyblue": 				Color = "#87CEEB"
			Case "lightskyblue": 			Color = "#87CEFA"
			Case "deepskyblue": 			Color = "#00BFFF"
			Case "dodgerblue": 				Color = "#1E90FF"
			Case "cornflowerblue": 			Color = "#6495ED"
			Case "mediumslateblue": 		Color = "#7B68EE"
			Case "royalblue": 				Color = "#4169E1"
			Case "blue": 					Color = "#0000FF"
			Case "mediumblue": 				Color = "#0000CD"
			Case "darkblue": 				Color = "#00008B"
			Case "navy": 					Color = "#000080"
			Case "midnightblue": 			Color = "#191970"
			'Brown HTML Color Names
			Case "cornsilk": 				Color = "#FFF8DC"
			Case "blanchedalmond": 			Color = "#FFEBCD"
			Case "bisque": 					Color = "#FFE4C4"
			Case "navajowhite": 			Color = "#FFDEAD"
			Case "wheat": 					Color = "#F5DEB3"
			Case "burlywood": 				Color = "#DEB887"
			Case "tan": 					Color = "#D2B48C"
			Case "rosybrown": 				Color = "#BC8F8F"
			Case "sandybrown": 				Color = "#F4A460"
			Case "goldenrod": 				Color = "#DAA520"
			Case "darkgoldenrod": 			Color = "#B8860B"
			Case "peru": 					Color = "#CD853F"
			Case "chocolate": 				Color = "#D2691E"
			Case "saddlebrown": 			Color = "#8B4513"
			Case "sienna": 					Color = "#A0522D"
			Case "brown": 					Color = "#A52A2A"
			Case "maroon": 					Color = "#800000"
			'White HTML Color Names
			Case "white": 					Color = "#FFFFFF"
			Case "snow": 					Color = "#FFFAFA"
			Case "honeydew": 				Color = "#F0FFF0"
			Case "mintcream": 				Color = "#F5FFFA"
			Case "azure": 					Color = "#F0FFFF"
			Case "aliceblue": 				Color = "#F0F8FF"
			Case "ghostwhite": 				Color = "#F8F8FF"
			Case "whitesmoke": 				Color = "#F5F5F5"
			Case "seashell": 				Color = "#FFF5EE"
			Case "beige": 					Color = "#F5F5DC"
			Case "oldlace": 				Color = "#FDF5E6"
			Case "floralwhite": 			Color = "#FFFAF0"
			Case "ivory": 					Color = "#FFFFF0"
			Case "antiquewhite": 			Color = "#FAEBD7"
			Case "linen": 					Color = "#FAF0E6"
			Case "lavenderblush": 			Color = "#FFF0F5"
			Case "mistyrose": 				Color = "#FFE4E1"
			'Gray HTML Color Names
			Case "gainsboro": 				Color = "#DCDCDC"
			Case "lightgray": 				Color = "#D3D3D3"
			Case "silver": 					Color = "#C0C0C0"
			Case "darkgray": 				Color = "#A9A9A9"
			Case "gray": 					Color = "#808080"
			Case "dimgray": 				Color = "#696969"
			Case "lightslategray": 			Color = "#778899"
			Case "slategray": 				Color = "#708090"
			Case "darkslategray": 			Color = "#2F4F4F"
			Case "black": 					Color = "#000000"
		End Select
	End If 
	If Color.StartsWith("#") Then 
		If Color.Length = 7 Then 
			R = ToDecimal(Mid(Color, 1, 2))
			G = ToDecimal(Mid(Color, 3, 2))
			B = ToDecimal(Mid(Color, 5, 2))
		else if Color.Length = 9 Then 
			Alpha = ToDecimal(Mid(Color, 1, 2))
			R = ToDecimal(Mid(Color, 3, 2))
			G = ToDecimal(Mid(Color, 5, 2))
			G = ToDecimal(Mid(Color, 7, 2))
		End If
		Return Colors.ARGB(Alpha,R,G,B)
	End If
	Return TheDefaultFontColor
End Sub

private Sub GetBetween(Text As String, Start As String, Finish As String) As String 
	Dim Temp As Int,temp2 As Int
	Temp=Text.IndexOf(Start)
	If Temp>-1 Then
		temp2=Text.IndexOf2(Finish, Temp+ Start.Length  +1)
		Return Mid(Text, Temp+Start.Length,temp2-Temp-Start.Length)
	End If
	Return ""
End Sub

public Sub GetFontName(FontID As Int) As String 
	If FontID > -1 And FontID < Fonts.Size Then 
		Dim Font As FontInfo = Fonts.Get(FontID)
		Return Font.Name
	Else 
		Select Case FontID
			Case -2: Return "default"
			Case -3: Return "default bold"
			Case -4: Return "monospace"
			Case -5: Return "sans serif"
			Case -6: Return "serif"
		End Select
	End If 
	Return "[INVALID]"
End Sub

public Sub ToDecimal(Hexadecimal As String) As Int 
	Return Bit.ParseInt(Hexadecimal, 16)
End Sub

public Sub setDefaultFontSize(Size As Int)
	TheDefaultFontSize = Size 
End Sub
public Sub getDefaultFontSize As Int
	Return TheDefaultFontSize
End Sub

'Returns what the Font size should be to fit the parsed HTML into MaxWidth
public Sub ScaleFontSizeWidth(MaxWidth As Int) As Int 
	Return ScaleFontSizeWidthAndHeight(MaxWidth, -1)
End Sub
'Returns what the Font size should be to fit the parsed HTML into MaxHeight
public Sub ScaleFontSizeHeight(MaxHeight As Int) As Int 
	Return ScaleFontSizeWidthAndHeight(-1, MaxHeight)
End Sub

public Sub RemoveWordWrap()
	Dim temp As Int, Info As TextInfo, OldInfo As TextInfo
	For temp = ParsedHTML.Size-1 To 0 Step -1 'remove all unnatural/artificial CRLFs
		Info = ParsedHTML.Get(temp)
		If Info.Align = TAG_CRLF Then 
			ParsedHTML.RemoveAt(temp)
			If temp < ParsedHTML.Size And temp > 0 Then 
				OldInfo = ParsedHTML.Get(temp)
				Info = ParsedHTML.Get(temp-1)
				If FontInfosMatch(OldInfo, Info) Then 
					Info.Text = Info.Text & " " & OldInfo.Text
					TextWidth(Info)
					ParsedHTML.RemoveAt(temp)
				End If 
			End If
		End If
	Next
	CalculateHTMLSize(False)
	WasSplit = -1 
End Sub

private Sub TextWidth(Info As TextInfo) As Int 
	Info.Width = BG.MeasureStringWidth(Info.Text.Replace("&NBSP;", " "), Info.Font, Info.Size)
	Return Info.Width 
End Sub

'Resizes the parsed HTML so the sizes relative to DefaultFontSize are now relative to FontSize (does not apply word wrapping)
public Sub ResizeHTML(FontSize As Int)
	Dim temp As Int, Info As TextInfo
	RemoveWordWrap
	For temp = 0 To ParsedHTML.Size-1 
		Info = ParsedHTML.Get(temp)
		If Info.Align>0 Then Info.Size = Info.Size - TheDefaultFontSize + FontSize
		If Info.Align>0 Or Info.Align = TAG_IMG Then 
			Info.Width = 0
			Info.Height = 0
			Info.LineHeight = 0
		End If
	Next
	TheDefaultFontSize = FontSize
End Sub

'Returns the length of text + 1 digit per image (for use with the typewriter effect)
public Sub MaxLength As Int 
	Dim temp As Int, Info As TextInfo, Length As Int 
	For temp = 0 To ParsedHTML.Size-1 
		Info = ParsedHTML.Get(temp)
		Length = Info.Length + Length 
	Next
	Return Length
End Sub


public Sub CalculateHTMLSize(ForceRefresh As Boolean) 'As Int 
	Dim temp As Int, Info As TextInfo, Image As ImageInfo
	LineHeight = 0
	For temp = 0 To ParsedHTML.Size-1
		Info = ParsedHTML.Get(temp)
		If Info.Align > 0 Then 
			If ForceRefresh Or Info.Width = 0 Then TextWidth(Info)'.Width = BG.MeasureStringWidth(Info.Text, Info.Font, Info.Size)
			If ForceRefresh Or Info.Height = 0 Then 
				Info.LineHeight = BG.MeasureStringHeight(Info.Text.ToUpperCase, Info.Font, Info.Size)
				Info.Height = BG.MeasureStringHeight(Info.Text, Info.Font, Info.Size)
			End If
			LineHeight = Max(LineHeight, Info.Height)
		End If 
	Next
	For temp = 0 To ParsedHTML.Size-1
		Info = ParsedHTML.Get(temp)
		If Info.Align = TAG_IMG Then 
			If Info.Height <> LineHeight Then 
				Image = Images.Get( Info.Size )
				Info.Height = LineHeight
				Info.Width = Image.BMP.Width / Image.BMP.Height  * Info.Height
			End If
		End If
	Next 
End Sub

public Sub IncrementTimer
	Dim Height As Int, Typewriter_Speed As Int, CurrentInfo As TextInfo
	If HTMLisLoaded Then 
		If ScrollSpeed <> 0 Then 
			StartY = StartY + ScrollSpeed 
			Height = DestinationRect.Height+TotalHeight', TotalHeight)
			If StartY <= -Height Or StartY >= Height Then 
				ClearHTML
				RaiseEvent("ScrollDone")
			End If
		End If 
		If TypeWriterSpeed = 0 Then TypeWriterLength = -1
		If TypeWriterLength > -1 Then 
			CurrentInfo = GetCurrentTagIndex(TypeWriterLength)
			Typewriter_Speed = CurrentInfo.Speed
			
			If TypeWriterLength < TotalLength Then 
				If Typewriter_Speed > 0 Then 
					TypeWriterLength = Min(TypeWriterLength + Typewriter_Speed, TotalLength)
				Else if Frame Mod Abs(Typewriter_Speed) = 0 Then 
					TypeWriterLength = Min(TypeWriterLength + 1, TotalLength)
				End If 
				Frame = Frame + 1
			Else 
				Frame = -1
				TypeWriterLength = -1
				RaiseEvent("TypewriterDone")
			End If 
			'Log("TypeWriterLength BEFORE: " & Before & " AFTER: " & TypeWriterLength & " TotalLength: " & TotalLength & " TypeWriterSpeed: " & TypeWriterSpeed)
		End If
	End If 
End Sub

public Sub HTMLisLoaded As Boolean 
	If ParsedHTML.IsInitialized Then Return ParsedHTML.Size>0 'And DestinationRect.IsInitialized
	Return False 
End Sub

public Sub StartTypewriter As Boolean 
	If HTMLisLoaded And TypeWriterLength = -1 Then 
		TypeWriterLength = 0
		Return True 
	End If
	Return False 
End Sub
'Returns True if the typewriter was in progress, false if it was already done 
public Sub AbortTypewriter As Boolean 
	If HTMLisLoaded And TypeWriterLength > -1 And TypeWriterLength < TotalLength Then 
		TypeWriterLength = -1
		RaiseEvent("TypewriterDone")
		Return True 
	End If
	Return False 
End Sub


'Returns what the Font size should be to fit the parsed HTML into MaxWidth and MaxWidth
public Sub ScaleFontSizeWidthAndHeight(MaxWidth As Int, MaxHeight As Int) As Int 
	'use GetTextLimitedHeight GetTextHeight
End Sub

'Splits the parsed HTML up so it fits within Width on multiple lines
public Sub WordWrapHTML(Width As Int) As Int 
	Dim temp As Int, Info As TextInfo, tempstr As String, LineWidth As Int , temp2 As Int, Lines As Int = 1
	RemoveWordWrap
	Do Until temp > ParsedHTML.Size -1 
		Info = ParsedHTML.Get(temp)'CutTextAtWidth
		If Info.Align > 0 Then  
			If LineWidth + Info.Width > Width Then 
				temp2 = CutTextAtWidth(Info.Text, Info.Font, Info.Size, Width - LineWidth, LineWidth = 0)
				If temp2 = 0 Then 
					ParsedHTML.InsertAt(temp, MakeSpecialTag(TAG_CRLF))'unnatural CRLF
					LineWidth = 0'BG.MeasureStringWidth(Info.Text.Replace("&NBSP;", " "), Info.Font, Info.Size)
					temp = temp + 1
				Else 
					tempstr = Info.Text
					SetTextParameter(Info, "text", Left(Info.Text, temp2))
					ParsedHTML.InsertAt(temp+1, MakeSpecialTag(TAG_CRLF))'unnatural CRLF
					ParsedHTML.InsertAt(temp+2, CopyTextParameters(Info))
					Info = ParsedHTML.Get(temp+2)
					SetTextParameter(Info, "text", Right(tempstr, tempstr.Length - temp2))
				End If
			Else 
				LineWidth = LineWidth + Info.Width
			End If
		Else 
			Select Case Info.Align
				Case TAG_CRLF, TAG_CRLF_Natural'newline
					LineWidth = 0
					Lines = Lines + 1
				Case TAG_IMG'image
					If LineWidth + Info.Width > Width Then 
						LineWidth = Info.Width
						Lines = Lines + 1
					Else 
						LineWidth = LineWidth + Info.Width
					End If
			End Select
		End If 
		temp = temp + 1
	Loop
	WasSplit = Width 'WordWrapHTML
	TotalHeight = Lines * LineHeight
	Return Lines
End Sub

Sub GetCurrentTagIndex(TypewriterValue As Int) As TextInfo
	Dim temp As Int = FindCurrentTagIndex(TypewriterValue)
	If temp = -1 Then Return LoadDefaultTextParameters
	Return ParsedHTML.Get(temp)
End Sub
Sub FindCurrentTagIndex(TypewriterValue As Int) As Int 
	Dim temp As Int, Info As TextInfo, tempstr As String 
	If Not(HTMLisLoaded) Or TypewriterValue = -1 Then Return -1 
	For temp = 0 To ParsedHTML.Size-1
		Info = ParsedHTML.Get(temp)
		If Info.Align > 0 Then 
			tempstr = Info.Text.Replace("&NBSP;", " ")
			TypewriterValue = TypewriterValue - tempstr.Length
		Else if Info.Align = TAG_IMG Then 
			TypewriterValue = TypewriterValue - 1
		End If 
		If TypewriterValue < 1 Then Return temp 
	Next 
	Return ParsedHTML.Size-1
End Sub

'Returns true if it can be drawn
public Sub DrawHTML() As Boolean 
	If Not(DestinationRect.IsInitialized) Or Not(HTMLisLoaded) Then Return False
	Dim X As Int = DestinationRect.Left, Y As Int = DestinationRect.Top, Width As Int = DestinationRect.Width, Height As Int = DestinationRect.Height, TypeWriterLength2 As Int = TypeWriterLength
	Dim tempX As Int = X, temp As Int, Info As TextInfo, NeedsClip As Boolean = Width > 0 And Height > 0, Image As ImageInfo, PrevWasCRLF As Boolean
	If WasSplit <> Width Then 
		If Width > 0 Then WordWrapHTML(Width) 
	else If LineHeight = 0 Then 
		CalculateHTMLSize(False)
	End If 
	If NeedsClip Then 
		MakeClipPath(X,Y,Width,Height)
		If BackgroundColor <> Colors.Transparent Then 
			BG.DrawRect(DestinationRect, BackgroundColor, True, 0)
		else if Background.IsInitialized Then 
			BG.DrawBitmap(Background, Null, DestinationRect)
		End If 
	End If
	Y = Y - StartY
	For temp = 0 To ParsedHTML.Size-1
		Info = ParsedHTML.Get(temp)
		If Info.Align > 0 Then 
			TypeWriterLength2 = DrawHTMLsegment(Info, X,Y, PrevWasCRLF, TypeWriterLength2)
			PrevWasCRLF = False 
		Else 
			Select Case Info.Align
				Case TAG_CRLF, TAG_CRLF_Natural
					Y = Y + LineHeight
					X = tempX
					PrevWasCRLF = True 
				Case TAG_IMG
					Image = Images.Get(Info.Size)
					If X + Info.Width > Width Then 
						Y = Y + LineHeight
						X = 0
					End If
					If IsInside(DestinationRect, X, Y, Info.Width, Info.Height) Then 
						BG.DrawBitmap(Image.BMP, Null, SetRect(X, Y, Info.Width, Info.Height))
					End If 
					If TypeWriterLength2 > -1 Then TypeWriterLength2 = TypeWriterLength2 - 1
			End Select
		End If 
		X = X + Info.Width
		If TypeWriterLength2 = 0 Then temp = ParsedHTML.Size
	Next
	If NeedsClip Then BG.RemoveClip
	Return True 
End Sub
Sub DrawHTMLsegment(Info As TextInfo, X As Int, Y As Int, PrevWasCRLF As Boolean, MaxChars As Int) As Int 
	Dim tempstr As String = Info.Text.Replace("&NBSP;", " "), Width As Int = Info.Width, Stroke As Int = 1
	Select Case Info.Align
		Case 7,8,9: Y = Y + Info.LineHeight'top
		Case 4,5,6: Y = Y + LineHeight * 0.5 - Info.LineHeight * 0.5'middle
		Case 1,2,3: Y = Y + LineHeight'bottom
	End Select		
	If PrevWasCRLF And tempstr.StartsWith(" ") Then tempstr = Right(tempstr, tempstr.Length-1)
	If MaxChars > -1 And MaxChars < tempstr.Length Then 
		tempstr = Left(tempstr, MaxChars)
		Width = BG.MeasureStringWidth(tempstr, Info.Font, Info.Size)
	End If
	If IsInside(DestinationRect, X, Y-LineHeight, Info.Width, LineHeight) Then 
		BG.DrawText(tempstr, X, Y, Info.Font, Info.Size, Info.Color, "LEFT")
		If Info.Underline Then 
			BG.DrawLine(X, Y, X + Width, Y, Info.Color, Stroke)
		End If
	End If 
	If MaxChars > -1 Then MaxChars = MaxChars - tempstr.Length
	Return MaxChars
End Sub


Sub IsInside(R As Rect, X As Int, Y As Int, Width As Int, Height As Int) As Boolean 
	Dim temp As Int = X + Width 
	If (X >= R.Left And X < R.Right) Or (temp >= R.Left And temp <= R.Right) Or (X < R.Left And temp > R.Right) Then 
		temp = Y + Height 
		Return (Y >= R.Top And Y < R.Bottom) Or (temp >= R.Top And temp <= R.Bottom) Or (Y < R.top And temp > R.Bottom)
	End If
	Return False 
End Sub



Sub SetRect(X As Int, Y As Int, Width As Int, Height As Int) As Rect 
	Dim Rect1 As Rect 
	Rect1.Initialize(X,Y,X+Width-1,Y+Height-1)
	Return Rect1
End Sub

Sub MakeClipPath(X As Int, Y As Int, Width As Int, Height As Int)' As Rect 
	Dim P As Path 
	P.Initialize(X,Y)
	P.LineTo(X+Width,Y)
	P.LineTo(X+Width,Y+Height)
	P.LineTo(X,Y+Height)
	BG.ClipPath(P)
	'Return SetRect(X,Y,Width,Height)
End Sub

public Sub FindImage(Name As String) As Int 
	Dim temp As Int, Image As ImageInfo
	Name = CleanName(Name)
	For temp = 0 To Images.Size - 1
		Image = Images.Get(temp)
		If CleanName(Image.Name) = Name Then Return temp 
	Next
	Return -1 
End Sub
public Sub LoadImageFromFile(Dir As String, Filename As String) As Int 
	Dim RET As Int = FindImage(Filename), Image As ImageInfo
	If RET > -1 Then Return RET 
	If Not(File.Exists(Dir, Filename)) Then Return -1 
	Image.Initialize
	Image.BMP.Initialize(Dir, Filename)
	Image.Name = CleanName(Filename)
	Images.Add(Image)
	Return Images.Size -1
End Sub
public Sub LoadImage(BMP As Bitmap, Name As String) As Int 
	Dim RET As Int = FindImage(Name), Image As ImageInfo
	If RET > -1 Then Return RET 
	Image.Initialize
	Image.BMP = BMP
	Image.Name = CleanName(Name)
	Images.Add(Image)
	Return Images.Size -1
End Sub








private Sub CleanName(Name As String) As String
	Return Name.Trim.ToLowerCase.Replace("_", " ")
End Sub

public Sub FindFont(Name As String) As Int 
	Dim temp As Int, Font As FontInfo, OriginalName As String = Name 
	Name = CleanName(Name)
	Select Case Name 
		Case "default": 		Return -2
		Case "default bold": 	Return -3
		Case "monospace":		Return -4
		Case "sans serif":		Return -5
		Case "serif": 			Return -6
	End Select
	For temp = 0 To Fonts.Size-1 
		Font = Fonts.Get(temp)
		If Font.Name = Name Then Return temp 
	Next
	Return AddFontFile(OriginalName, "[SKIPCHECK]")
End Sub

'Returns the FontID of the loaded font, or -1 if the filename is not found in the asset directory
public Sub AddFontFile(Filename As String, Name As String) As Int
	Dim RET As Int
	If Name = "[SKIPCHECK]" Then 
		Name = Filename
	Else 
		RET = FindFont(Name)
		If RET <> -1 Then Return RET  
	End If 
	If Not(File.Exists(File.DirAssets, Filename)) Then Return -1 
	Return AddFont(Typeface.LoadFromAssets(Filename), Name)
End Sub
'Returns the FontID of the loaded font
public Sub AddFont(Font As Typeface, Name As String) As Int 
	Dim RET As Int = FindFont(Name) 
	If RET <> -1 Then Return RET 
	Dim FontI As FontInfo
	FontI.Initialize 
	FontI.Font = Font 
	FontI.Name = CleanName(Name)
	Fonts.Add(FontI)
	Return Fonts.Size-1
End Sub

private Sub LoadFont(FontID As Int, Bold As Boolean, Italic As Boolean) As Typeface
	Dim Font As Typeface, 	Style As Int = Typeface.STYLE_NORMAL 
	If Bold Then 			Style = Typeface.STYLE_BOLD
	If Italic Then 			Style = Typeface.STYLE_ITALIC
	If Bold And Italic Then Style = Typeface.STYLE_BOLD_ITALIC
	Select Case FontID 
		Case -2: 			Font = Typeface.DEFAULT
		Case -3: 			Font = Typeface.DEFAULT_BOLD
		Case -4: 			Font = Typeface.MONOSPACE
		Case -5: 			Font = Typeface.SANS_SERIF
		Case -6: 			Font = Typeface.SERIF
		Case -1: 			Return Font 
		Case Else 
			Dim FontI As FontInfo = Fonts.Get(FontID)
			Font = FontI.Font
	End Select 
	If Style = Typeface.STYLE_NORMAL Then Return Font 
	Return Typeface.CreateNew(Font, Style)
End Sub








'HTML must have already been split up by SplitHTML
'Returns -1 if successful, otherwise the index on which it failed
Public Sub IsValidHTML(HTML As List) As Int
	Dim temp As Int, Tags As List, tempstr As String, Parse As Map, TagName As String 
	Tags.Initialize
	For temp = 0 To HTML.Size-1
		tempstr = HTML.Get(temp)
		If IsHTML(tempstr) Then 
			Parse = ParseTag(tempstr)'tag_name, tag_closing: open <TAG>, end <TAG/>, start </TAG>, singleton <BR>
			If Not(Parse.ContainsKey("tag_name")) Then Return temp 
			TagName = Parse.Get("tag_name")
			Select Case Parse.Get("tag_closing")
				Case "open"
					Tags.Add(TagName)
				Case "start"
					If Tags.Size = 0 Then Return temp 
					If Tags.Get(Tags.Size-1) = TagName Then 
						Tags.RemoveAt(Tags.Size-1)
					Else 
						Return temp 
					End If
				'Case "end", "singleton"
			End Select
		End If
	Next
	Return -1 
End Sub
public Sub SplitHTML(HTML As String) As List 
	Dim RET As List, tempstr As String, Start As Int, Finish As Int 
	RET.Initialize
	Do Until HTML.Length = 0
		Start = Instr(HTML, "<", 0)
		tempstr = ""
		If Start > 0 Then 
			tempstr = Left(HTML, Start)
			RET.Add(tempstr)
			HTML = Right(HTML, HTML.Length - tempstr.Length)
			tempstr = ""
		else if Start = -1 And HTML.Length > 0 Then  
			tempstr = HTML
		End If
		If Start > -1 Then 'CurrentHTMLtag = 
			Finish = HTML.IndexOf(">")
			tempstr = Left(HTML, Finish+1)
		End If
		If tempstr.Length > 0 Then 
			RET.Add(tempstr)
			HTML = Right(HTML, HTML.Length - tempstr.Length)
		End If
	Loop
	Return RET 
End Sub
public Sub ParseHTML(HTML As String) As List 
	Dim Source As List = SplitHTML(HTML), temp As Int, CurrentTextParameters As TextInfo, tempstr As String, RET As List, TagInfo As Map, IsClosing As Boolean, NeedsRefreshing As Boolean, temp2 As Int, Error As Boolean, PreviousTextParameter As TextInfo
	Dim Hierarchy As List 
	Hierarchy.Initialize
	CurrentTextParameters = LoadDefaultTextParameters
	ProcessCSS(CurrentTextParameters, "body, html", Hierarchy) 	
	PreviousTextParameter = CopyTextParameters(CurrentTextParameters)
	FailedOn = IsValidHTML(Source)
	If FailedOn > -1 Then Return RET 
	RET.Initialize
	'Log("SOURCE: " & Source)
	For temp = 0 To Source.Size-1
		tempstr = Source.Get(temp)
		TagInfo = ParseTag(tempstr)
		Error = Not(TagInfo.IsInitialized)
		If Not(Error) Then 
			'Log("INDEX: " & temp & " HTML: " & tempstr & " TAG: " & TagInfo.Get("tag_name") & " TYPE: " & TagInfo.Get("tag_closing"))
			CurrentTextParameters.TagID = temp 
			NeedsRefreshing = False 
			IsClosing = TagInfo.Get("tag_closing") = "start"'open <TAG>, end <TAG/>, start </TAG>, singleton <BR>
			If IsClosing Then 
				NeedsRefreshing = True
				Log("CLOSING TAG FOUND AT " & temp)
				temp2 = FindStartOfTag(Source, temp, TagInfo.Get("tag_name"))
				Error = temp2 = -1
				If Not(Error) Then 
					temp2 = FindTagID(RET, temp2)
					Error = temp2 = -1
					If Not(Error) Then
						CurrentTextParameters = FindPreviousTextParameter(RET, temp2)'CopyTextParameters(RET.Get(temp2))
						CurrentTextParameters.Text = ""
						PreviousTextParameter = CopyTextParameters(CurrentTextParameters)' FindPreviousTextParameter(RET, temp2):PreviousTextParameter.Text = ""
					End If
				End If
			Else 
				If Not(TagInfo.Get("tag_closing") = "open") Then PreviousTextParameter = CopyTextParameters(CurrentTextParameters)
				Hierarchy.Add( HandleHierarchy(TagInfo.Get("tag_name"), TagInfo.GetDefault("id", ""), TagInfo.GetDefault("class", "")) )
				Select Case TagInfo.Get("tag_name")
					Case "img"
						If TagInfo.ContainsKey("src") Then 
							Dim ImageTag As TextInfo = MakeImage(TagInfo.Get("src"))
							If ImageTag.IsInitialized Then RET.Add(ImageTag)
						End If
					Case "b": CurrentTextParameters.Bold = True: 		NeedsRefreshing = True
					Case "i": CurrentTextParameters.Italic = True: 		NeedsRefreshing = True
					Case "u": CurrentTextParameters.Underline = True
					Case "font"
						If TagInfo.ContainsKey("face") Then SetTextParameter(CurrentTextParameters, "font", TagInfo.Get("face"))
						If TagInfo.ContainsKey("size") Then 
							Select Case TagInfo.Get("size")
								Case "xx-smaller":	TagInfo.Put("size", PreviousTextParameter.Size-3)
								Case "x-smaller":	TagInfo.Put("size", PreviousTextParameter.Size-2)
								Case "smaller": 	TagInfo.Put("size", PreviousTextParameter.Size-1)
								Case "inherit": 	TagInfo.Put("size", PreviousTextParameter.Size)
								Case "larger":  	TagInfo.Put("size", PreviousTextParameter.Size+1)
								Case "x-larger":  	TagInfo.Put("size", PreviousTextParameter.Size+2)
								Case "xx-larger":  	TagInfo.Put("size", PreviousTextParameter.Size+3)
							End Select
							SetTextParameter(CurrentTextParameters, "size", TagInfo.Get("size"))
						End If
						If TagInfo.ContainsKey("color") Then SetTextParameter(CurrentTextParameters, "color", TagInfo.Get("color"))
					Case "br", "p"
						RET.Add(MakeSpecialTag(TAG_CRLF_Natural))			
					Case "slow"
						CurrentTextParameters.Speed = TypeWriterSpeed * 0.5
					Case "fast"
						CurrentTextParameters.Speed = TypeWriterSpeed * 2
				End Select
				If Not(TagInfo.Get("tag_closing") = "open") Then CurrentTextParameters = CopyTextParameters(PreviousTextParameter) 
			End If 
			If TagInfo.Get("tag_closing") = "open" Then 
				ProcessCSS(CurrentTextParameters, ClassToCSS(TagInfo.Get("tag_name"), TagInfo.GetDefault("class", " "), TagInfo.GetDefault("id", "")), Hierarchy)
				If TagInfo.ContainsKey("style") Then 
					LoadCSSpart(".anonymous" & AnonymousCSS & "{" & TagInfo.Get("style") & "}",  -1, -1, "anonymous")
					ProcessCSS(CurrentTextParameters, ".anonymous" & AnonymousCSS, Hierarchy)
					AnonymousCSS = AnonymousCSS + 1
				End If
			Else 
				Hierarchy.RemoveAt( Hierarchy.Size-1 )
			End If
			
			If NeedsRefreshing Then RefreshFont(CurrentTextParameters)
		Else 
			HandleText(tempstr, CurrentTextParameters, RET)
		End If
	Next 
	Return RET 
End Sub

Private Sub IsCSScomplex(Selector As String) As Boolean 
	Dim Characters() As String = Array As String(" ", ".", "#", ">", ":", "~", "[", "]", "=", "+"), temp As Int 
	For temp = 0 To Characters.length - 1 
		If Instr(Selector, Characters(temp), 1) > -1 Then Return True 
	Next
	Return False 
End Sub
private Sub HandleHierarchy(TagType As String, ID As String, Class As String) As String 
	Dim tempstr As StringBuilder, Classes() As String = Regex.Split(" ", ReplaceMultiple(Class, "  ", " ")), temp As Int 
	tempstr.Initialize
	tempstr.Append(TagType)
	If ID.Length>0 Then tempstr.Append(", #" & ID)
	For temp = 0 To Classes.Length - 1 
		If Classes(temp).Length > 0 Then tempstr.Append(", ." & Classes(temp))
	Next
	Return tempstr.ToString
End Sub

private Sub FindPreviousTextParameter(TheParsedHTML As List, TagIndex As Int) As TextInfo
	Dim temp As Int, TagInfo As TextInfo
	If TagIndex > 0 Then 
		For temp = TagIndex-1 To 0 Step -1
			TagInfo = TheParsedHTML.Get(temp)
			If TagInfo.Align > 0 Then 
				Log("Found previous tag at " & temp)
				Return CopyTextParameters(TagInfo)
			End If
		Next
	End If 
	Return LoadDefaultTextParameters
End Sub
private Sub FindTagID(TheParsedHTML As List, TagID As Int) As Int 
	Dim temp As Int, HTML As TextInfo
	For temp = 0 To TheParsedHTML.Size-1
		HTML = TheParsedHTML.Get(temp)
		If HTML.TagID = TagID Then Return temp 
	Next
	Return -1 
End Sub
private Sub FindStartOfTag(HTML As List, CurrentIndex As Int, TagName As String) As Int 
	Dim temp As Int, tempstr As String, TagInfo As Map
	For temp = CurrentIndex-1 To 0 Step -1 
		tempstr = HTML.Get(temp)
		If IsHTML(tempstr) Then 	
			TagInfo = ParseTag(tempstr)
			If TagName.EqualsIgnoreCase(TagInfo.Get("tag_name")) Then Return temp 
		End If
	Next
	Return -1 
End Sub

private Sub IsHTML(Text As String) As String
	Return Text.StartsWith("<") And Text.EndsWith(">")
End Sub
private Sub HandleText(Text As String, CurrentTextParameters As TextInfo, RET As List)
	Dim TextParams As TextInfo, tempstr() As String, temp As Int
	If Text.Contains(CRLF) Then 
		tempstr = Regex.Split(CRLF, Text)
		For temp = 0 To tempstr.Length - 1 
			If temp > 0 Then RET.Add(MakeSpecialTag(TAG_CRLF_Natural))
			HandleText(tempstr(temp), CurrentTextParameters, RET)
		Next 
	Else If Text.Length > 0 Then 
		TextParams = CopyTextParameters(CurrentTextParameters)
		Text = HTMLentities(Replace(Text, "&nbsp;", "[NBSP]")).Replace("[NBSP]", "&NBSP;")
		TextParams.Text = Text 
		TextParams.Length = Text.Length
		RET.Add(TextParams)
	End If
End Sub

Sub MakeSpecialTag(Value As Int) As TextInfo
	Dim temp As TextInfo
	temp.Initialize
	temp.FontID = -1
	temp.Align = Value
	temp.DATA.Initialize
	Return temp 
End Sub

Sub LoadDefaultTextParameters As TextInfo
	Dim temp As TextInfo
	temp.Initialize
	temp.Align = 		TheDefaultAlignment
	temp.Bold = 		DefaultBold 
	temp.Italic = 		DefaultItalic
	temp.Color = 		TheDefaultFontColor
	temp.FontID = 		FindFont(TheDefaultFont)
	temp.Size = 		TheDefaultFontSize
	temp.Underline = 	DefaultUnderline
	temp.Speed = 		TypeWriterSpeed
	temp.BGColor = 		Colors.Transparent
	temp.DATA.Initialize
	Return temp 
End Sub
Sub SaveTextParametersToDefault(Data As TextInfo)
	TheDefaultAlignment = Data.Align
	DefaultBold			= Data.Bold
	DefaultItalic		= Data.Italic
	TheDefaultFontColor = Data.Color
	TheDefaultFont		= GetFontName(Data.FontID)
	TheDefaultFontSize  = Data.Size
	DefaultUnderline    = Data.Underline
	TypeWriterSpeed     = Data.Speed
	If Data.BGColor <> Colors.Transparent Then BackgroundColor = Data.BGColor
End Sub

Sub FontInfosMatch(Info1 As TextInfo, Info2 As TextInfo) As Boolean
	If Info1.FontID = Info2.FontID Then 
		If Info1.Align = Info2.Align Then 
			If Info1.Bold = Info2.Bold Then 
				If Info1.Color = Info2.Color Then 
					If Info1.Italic = Info2.Italic Then 
						If Info1.Underline = Info2.Underline Then 
							Return True 
						End If
					End If 
				End If
			End If
		End If
	End If
	Return False 
End Sub

public Sub MakeImage(ImageName As String) As TextInfo
	Dim temp As TextInfo, ID As Int = FindImage(ImageName)
	If ID = -1 Then Return temp 
	temp.Initialize
	temp.Text = CleanName(ImageName)
	temp.Align = TAG_IMG
	temp.FontID = -1 
	temp.Size = ID
	temp.Length = 1
	Return temp 
End Sub

public Sub ParseTag(Tag As String) As Map 
	Dim temp As Int, RET As Map, TagName As String
	If IsHTML(Tag) Then 
		RET.Initialize
		RET.Put("tag_closing", "open")'open, end, start, singleton
		Tag = Mid(Tag, 1, Tag.Length-2).Trim'cut off < and >
		If Tag.EndsWith("/") Then 
			Tag = Left(Tag, Tag.Length-1).Trim
			RET.Put("tag_closing", "end")
		End If
		temp = Instr(Tag, " ", 0)
		If temp = -1 Then 
			TagName = Tag.Trim.ToLowerCase
		Else 
			TagName = Left(Tag, temp).Trim.ToLowerCase
			Tag = Right(Tag, Tag.Length-temp)
			Do Until Tag.Length = 0
				Tag = ParseParameter(RET, Tag)
			Loop
		End If
		TagName = TagName.Trim.ToLowerCase
		If TagName.StartsWith("/") Then 
			TagName = Right(TagName, TagName.Length-1)
			RET.Put("tag_closing", "start")
		End If  
		Select Case TagName
			Case "area", "base", "br", "col", "command", "embed", "hr", "img", "input", "keygen", "link", "meta", "param", "source", "track", "wbr"
				RET.Put("tag_closing", "singleton")
		End Select
		If RET.ContainsKey("class") Then 
			Dim tempstr() As String = Regex.Split(" ", RET.Get("class")), Classes As Int 
			For temp = 0 To tempstr.Length
				If tempstr(temp).Length> 0 Then 
					RET.Put("tag_class" & Classes, tempstr(temp))
					Classes = Classes + 1
				End If
			Next
			RET.Put("tag_classes", Classes)
		End If
		RET.Put("tag_name", TagName)
	End If 
	Return RET 
End Sub
public Sub ParseParameter(RET As Map, Tag As String) As String 
	Dim ParamName As String, Value As String = "", temp As Int, CurrentLetter As String, IsInQuote As String, toParse As String, EqualSign As Int = -1
	Tag = Tag.Trim
	For temp = 0 To Tag.Length - 1 
		CurrentLetter = Mid(Tag, temp, 1)
		Select Case CurrentLetter
			Case """", "'"
				If IsInQuote.Length = 0 Then 
					IsInQuote = CurrentLetter
				else if IsInQuote = CurrentLetter Then 
					toParse = Left(Tag, temp+1)
					temp = Tag.Length
				End If
			Case " "
				If IsInQuote.Length = 0 Then 
					toParse = Left(Tag, temp)
					temp = Tag.Length
				End If
			Case "="
				If IsInQuote.Length = 0 Then EqualSign = temp 
		End Select
		If temp = Tag.Length -1 Then 
			toParse = Tag & IsInQuote
			Tag = ""
		End If
	Next
	If EqualSign = -1 Then 
		ParamName = toParse
	Else 
		ParamName = Left(toParse, EqualSign).Trim
		Value = Right(toParse, toParse.Length - EqualSign-1)
		Value = Value.Replace(IsInQuote, "").Trim
	End If
	If ParamName.Length>0 Then RET.Put(ParamName.Trim.ToLowerCase, Value)
	If Tag.Length > 0 Then Tag = Right(Tag, Tag.Length - toParse.Length).Trim
	Return Tag 
End Sub

public Sub CopyMap(Source As Map) As Map 
	Dim RET As Map, temp As Int
	RET.Initialize
	For temp = 0 To Source.Size-1
		RET.Put(Source.GetKeyAt(temp), Source.GetValueAt(temp))
	Next
	Return RET 	
End Sub

private Sub CopyTextParameters(TextParam As TextInfo) As TextInfo
	Dim temp As TextInfo
	temp.Initialize
	temp.Align = TextParam.Align
	temp.Text = TextParam.Text
	If temp.Align > 0 Then 
		temp.Bold = 		TextParam.Bold
		temp.Color = 		TextParam.Color
		temp.Underline = 	TextParam.Underline
		temp.FontID = 		TextParam.FontID
		temp.Italic = 		TextParam.Italic
		temp.Size = 		TextParam.Size
		temp.Font = 		RefreshFont(temp)
		temp.TagID = 		TextParam.TagID
		temp.Speed = 		TextParam.Speed
		temp.DATA = 		CopyMap(TextParam.DATA)
	End If 
	Return temp 
End Sub
'ParameterName: color, bold, italic, underline, size, font, align, text, speed, bgcolor
private Sub GetTextParameter(TextParam As TextInfo, ParameterName As String) As String
	Select Case CleanName(ParameterName)
		Case "color": 		Return TextParam.Color
		Case "bold":  		Return TextParam.Bold
		Case "italic": 		Return TextParam.Italic
		Case "align":		Return TextParam.Align
		Case "size": 		Return TextParam.Size
		Case "underline": 	Return TextParam.Underline
		Case "text":		Return TextParam.Text
		Case "font":		Return GetFontName(TextParam.FontID)	
		Case "speed":		Return TextParam.Speed
		Case "bgcolor": 	Return TextParam.BGColor
	End Select
	Return TextParam.DATA.GetDefault(ParameterName, "")
End Sub


private Sub StartsWith(Text As String, EndsWith As String) As String 
	If Text.EndsWith(EndsWith) Then Return Left(Text, Text.Length - EndsWith.Length).Trim
	Return Text
End Sub
private Sub smallerlarger(DefaultValue As Int, CurrentValue As Int, Value As String) As Int 
	Dim NoX As Int = 1, X As Int = 2, XX As Int = 3
	If Not(IsNumber(Value)) Then
		Value = Value.ToLowerCase.Trim	
		If DefaultValue > -1 Then 
			Select Case Value
				Case "xx-small", "xx-slow": 	Value = DefaultValue - XX
				Case "x-small", "x-slow":	 	Value = DefaultValue - X
				Case "small", "slow":	 		Value = DefaultValue - NoX
				Case "medium", "regular": 		Value = DefaultValue
				Case "large", "fast":	 		Value = DefaultValue + NoX
				Case "x-large", "x-fast":	 	Value = DefaultValue + X
				Case "xx-large", "xx-fast": 	Value = DefaultValue + XX
			End Select 
		End If 
		If CurrentValue > -1 And Not(IsNumber(Value)) Then 
			Select Case Value 
				Case "xx-smaller", "xx-slower":	Value = CurrentValue - XX
				Case "x-smaller", "x-slower": 	Value = CurrentValue - X
				Case "smaller", "slower":	 	Value = CurrentValue - NoX
				Case "larger", "faster": 		Value = CurrentValue + NoX
				Case "x-larger", "x-faster": 	Value = CurrentValue + X
				Case "xx-larger", "xx-faster": 	Value = CurrentValue + XX
			End Select
		End If 
	End If 
	Return Value 
End Sub

'ParameterName: color (HTMLcolor), bgcolor (HTMLcolor), bold (boolean), italic (boolean), underline (boolean), size (number, +/-number, xx-small, x-small, small, medium, large, x-large, xx-large), font (Font name), style (italic, bold, underline, default, regular/normal)
'Returns whether or not Value is valid for ParameterName
private Sub SetTextParameter(TextParam As TextInfo, ParameterName As String, Value As String) As Boolean
	Dim NeedsRefreshing As Boolean, tempstr() As String, temp As Int 
	ParameterName = CleanName(ParameterName)
	Select Case ParameterName
		Case "bold", "italic", "underline":	If Not(isabool(Value, False)) Then Return False 
		Case "align":		  				If Not(IsNumber(Value)) Then Return False 
		Case "size":
			If Value.Length = 0 Then Return False 
			Dim Direction As String = Left(Value, 1)
			If (Direction = "+" Or Direction = "-") And IsNumber(Right(Value, Value.Length-1)) Then 
				Value = Right(Value, Value.Length-1)
				If Direction = "+" Then Value = TheDefaultFontSize + Value 
				If Direction = "-" Then Value = TheDefaultFontSize - Value 
			else if Not(IsNumber(Value)) Then
				If Value.EndsWith("px") Then 
					Value = StartsWith(Value, "px")
					If IsNumber(Value) Then GetTextHeight(Value, TextParam.Text, TextParam.Font) Else Value = 0
				else if Value.EndsWith("%") Then 
					Value = StartsWith(Value, "%")
					If IsNumber(Value) Then GetTextHeight(Value * 0.01 * DestinationRect.Height, TextParam.Text, TextParam.Font) Else Value = 0
				Else if Value.EndsWith("dip") Then 
					Value = StartsWith(Value, "dip")
					If IsNumber(Value) Then Value = Value * 1dip Else Value = 0
				Else 
					Value = smallerlarger(TheDefaultFontSize, -1, Value)
				End If
			End If
			If Value < 1 Then Return False 
		Case "speed":						Value = smallerlarger(10, TypeWriterSpeed, Value)
	End Select
	Select Case ParameterName
		Case "style"
			tempstr = Regex.Split(Value, ",")
			For temp = 0 To tempstr.Length-1
				Select Case CleanName(tempstr(temp))
					Case "italic":  	TextParam.Italic = True
					Case "blod":		TextParam.Bold = True 
					Case "underline": 	TextParam.Underline = True 
					Case "default"
						TextParam.Italic = DefaultItalic
						TextParam.Bold = DefaultBold 
						TextParam.Underline = DefaultUnderline 
					Case "regular","normal"
						TextParam.Italic = False
						TextParam.Bold = False 
						TextParam.Underline = False 
				End Select
			Next
		Case "color": 		TextParam.Color = HTMLColor(Value, 255)
		Case "bgcolor":		TextParam.BGColor = HTMLColor(Value, 255)': Log("Setting BGColor to: " & MakeHTMLColor(TextParam.BGColor))
		Case "align":		TextParam.Align = Value 
		Case "size": 		TextParam.Size = Value 
		Case "underline": 	TextParam.Underline = ToBool(Value)
		Case "bold"
			TextParam.Bold = ToBool(Value)
			NeedsRefreshing = True 
		Case "italic"
			TextParam.Italic = ToBool(Value)
			NeedsRefreshing = True 
		Case "font"
			Dim FontID As Int = FindFont(Value)
			If FontID = -1 Then Return False 
			TextParam.FontID = FontID
			NeedsRefreshing = True 
		Case "text" 
			TextParam.Text = Value 
			TextWidth(TextParam) 'BG.MeasureStringWidth(TextParam.Text, TextParam.Font, TextParam.Size)
			TextParam.Height = BG.MeasureStringHeight(TextParam.Text, TextParam.Font, TextParam.Size)
			TextParam.LineHeight = BG.MeasureStringHeight(TextParam.Text.ToUpperCase, TextParam.Font, TextParam.Size)
			LineHeight = Max(LineHeight, TextParam.Height)
		Case "speed"
			TextParam.Speed = Value 
		Case Else 
			TextParam.DATA.Put(ParameterName, Value)
	End Select
	If NeedsRefreshing Then TextParam.Font = RefreshFont(TextParam)
	Return True 
End Sub
private Sub RefreshFont(TextParam As TextInfo) As Typeface
	Return LoadFont(TextParam.FontID, TextParam.Bold, TextParam.Italic)
End Sub
private Sub ToBool(Text As String) As Boolean 
	Select Case Text.ToLowerCase 
		Case "true", "1": Return True
	End Select
	Return False 
End Sub
private Sub isabool(Text As String, OnlyText As Boolean) As Boolean 
	Select Case Text.ToLowerCase 
		Case "true", "false": Return True
		Case "0", "1": Return Not(OnlyText)
	End Select
	Return False
End Sub


private Sub isHex(Text As String) As Boolean 
	Dim temp As Int, tempstr As String, A As Int = Asc("a"), F As Int = Asc("f"), temp2 As Int 
	For temp = 0 To Text.Length-1
		tempstr = Mid(Text, temp, 1)
		If Not(IsNumber(tempstr)) Then 
			temp2 = Asc(tempstr.ToLowerCase)
			If temp2 < A Or temp2 > F Then Return False 
		End If
	Next
	Return True
End Sub
private Sub IsLcase(Text As String) As Boolean 
	Dim A As Int = Asc("a"), Z As Int = Asc("z"), Digit As Int, temp As Int
	For temp = 0 To Text.Length-1
		Digit = Asc(Mid(Text, temp, 1))
		If Digit < A Or Digit > Z Then Return False 
	Next
	Return True
End Sub
private Sub IIF(Value As Boolean , IFtrue As Object, IfFalse As Object) As Object
	If Value Then Return IFtrue 
	Return IfFalse
End Sub
public Sub HTMLentities(Text As String) As String 
	Dim Index As Int = Text.IndexOf("&"), Index2 As Int, tempstr As String, tempstr2 As String, Value As Int = -1, IsLcased As Boolean 
	Do While Index > -1 
		Index2 = Text.IndexOf2(";", Index)
		If Index2 = -1 Then 
			Index = -1 
		Else 
			tempstr = Mid(Text, Index + 1, Index2 - Index - 1)
			Value = -1
			If tempstr.StartsWith("#") Then'&#nnnn; where nnnn = decimal number 
				tempstr2 = tempstr.Length-1
				If IsNumber(tempstr2) Then Value = tempstr2
			else if tempstr.StartsWith("#x") Then'&#xhhhh; where hhhh = hexadecimal number
				tempstr2 = Right(tempstr, tempstr.Length-2)
				If isHex(tempstr2) Then Value = ToDecimal(tempstr2)
			End If
			If Value = -1 Then '&name; where name = name of entity
				tempstr2 = ""
				IsLcased = IsLcase(tempstr)
				Select Case tempstr.ToLowerCase
					Case "shy", "zwnj", "zwj", "lrm", "rlm": tempstr2 = ""'these are not handled properly
						
					Case "quot": 		tempstr2 = """"
					Case "amp":  		tempstr2 = "&"
					Case "nbsp":		tempstr2 = " "
					Case "apos":		tempstr2 = "'"
					Case "lt":			tempstr2 = "<"
					Case "gt":			tempstr2 = ">"
					Case "exclamation":	tempstr2 = "!"
					Case "percent":		tempstr2 = "%"
					Case "add":			tempstr2 = "+"
					Case "equal":		tempstr2 = "="
					Case "iexcl":		tempstr2 = "¡"
					Case "cent":		tempstr2 = "¢"
					Case "pound":		tempstr2 = "£"
					Case "curren":		tempstr2 = "¤"
					Case "yen":			tempstr2 = "¥"
					Case "brvbar":		tempstr2 = "¦"
					Case "sect":  		tempstr2 = "§"
					Case "uml":  		tempstr2 = "¨"
					Case "copy":  		tempstr2 = "©"
					Case "ordf":  		tempstr2 = "ª"
					Case "laquo":  		tempstr2 = "«"
					Case "not":  		tempstr2 = "¬"
					Case "reg":  		tempstr2 = "®"
					Case "macr":  		tempstr2 = "¯"
					Case "deg":  		tempstr2 = "°"
					Case "plusmn":  	tempstr2 = "±"
					Case "sup2":  		tempstr2 = "²"
					Case "sup3":  		tempstr2 = "³"
					Case "acute":  		tempstr2 = "´"
					Case "micro":  		tempstr2 = "µ"
					Case "para":  		tempstr2 = "¶"
					Case "middot":  	tempstr2 = "·"
					Case "cedil":  		tempstr2 = "¸"
					Case "sup1":  		tempstr2 = "¹"
					Case "ordm":  		tempstr2 = "º"
					Case "raquo":  		tempstr2 = "»"
					Case "frac14":  	tempstr2 = "¼"
					Case "frac12":  	tempstr2 = "½"
					Case "frac34":  	tempstr2 = "¾"
					Case "iquest":  	tempstr2 = "¿"
					Case "times":  		tempstr2 = "×"
					Case "szlig":  		tempstr2 = "ß"
					Case "fnof":  		tempstr2 = "ƒ"
					Case "circ":  		tempstr2 = "ˆ"
					Case "tilde":  		tempstr2 = "˜"
					Case "divide":  	tempstr2 = "÷"
							
					Case "agrave":  	tempstr2 = IIF(IsLcased, "à", "À")
					Case "aacute":  	tempstr2 = IIF(IsLcased, "á", "Á")
					Case "acirc":  		tempstr2 = IIF(IsLcased, "â", "Â")
					Case "atilde":  	tempstr2 = IIF(IsLcased, "ã", "Ã")
					Case "auml":  		tempstr2 = IIF(IsLcased, "ä", "Ä")
					Case "aring":  		tempstr2 = IIF(IsLcased, "å", "Å")
					Case "aelig":  		tempstr2 = IIF(IsLcased, "æ", "Æ")
					Case "ccedil":  	tempstr2 = IIF(IsLcased, "ç", "Ç")
					Case "egrave":  	tempstr2 = IIF(IsLcased, "è", "È")
					Case "eacute":  	tempstr2 = IIF(IsLcased, "é", "É")
					Case "ecirc":  		tempstr2 = IIF(IsLcased, "ê", "Ê")
					Case "euml": 		tempstr2 = IIF(IsLcased, "ë", "Ë")
					Case "igrave":  	tempstr2 = IIF(IsLcased, "ì", "Ì")
					Case "iacute":  	tempstr2 = IIF(IsLcased, "í", "Í")
					Case "icirc":  		tempstr2 = IIF(IsLcased, "î", "Î")
					Case "iuml":  		tempstr2 = IIF(IsLcased, "ï", "Ï")
					Case "eth":  		tempstr2 = IIF(IsLcased, "ð", "Ð")
					Case "ntilde":  	tempstr2 = IIF(IsLcased, "ñ", "Ñ")
					Case "ograve":  	tempstr2 = IIF(IsLcased, "ò", "Ò")
					Case "oacute":  	tempstr2 = IIF(IsLcased, "ó", "Ó")
					Case "ocirc":  		tempstr2 = IIF(IsLcased, "ô", "Ô")
					Case "otilde":  	tempstr2 = IIF(IsLcased, "õ", "Õ")
					Case "ouml":  		tempstr2 = IIF(IsLcased, "ö", "Ö")
					Case "oslash":  	tempstr2 = IIF(IsLcased, "ø", "Ø")
					Case "ugrave":  	tempstr2 = IIF(IsLcased, "ù", "Ù")
					Case "uacute":  	tempstr2 = IIF(IsLcased, "ú", "Ú")
					Case "ucirc":  		tempstr2 = IIF(IsLcased, "û", "Û")
					Case "uuml":  		tempstr2 = IIF(IsLcased, "ü", "Ü")
					Case "yacute":  	tempstr2 = IIF(IsLcased, "ý", "Ý")
					Case "thorn":  		tempstr2 = IIF(IsLcased, "þ", "Þ")
					Case "yuml":  		tempstr2 = IIF(IsLcased, "ÿ", "Ÿ")
					Case "oelig":  		tempstr2 = IIF(IsLcased, "œ", "Œ")
					Case "scaron":  	tempstr2 = IIF(IsLcased, "š", "Š")
					Case "dagger":  	tempstr2 = IIF(IsLcased, "†", "‡")
											
					Case "alpha":  		tempstr2 = IIF(IsLcased, "α", "Α")
					Case "beta":  		tempstr2 = IIF(IsLcased, "β", "Β")
					Case "gamma":  		tempstr2 = IIF(IsLcased, "γ", "Γ")
					Case "delta":  		tempstr2 = IIF(IsLcased, "δ", "Δ")
					Case "epsilon":  	tempstr2 = IIF(IsLcased, "ε", "Ε")
					Case "zeta":  		tempstr2 = IIF(IsLcased, "ζ", "Ζ")
					Case "eta":  		tempstr2 = IIF(IsLcased, "η", "Η")
					Case "theta":  		tempstr2 = IIF(IsLcased, "θ", "Θ")
					Case "iota":  		tempstr2 = IIF(IsLcased, "ι", "Ι")
					Case "kappa":  		tempstr2 = IIF(IsLcased, "κ", "Κ")
					Case "lambda":  	tempstr2 = IIF(IsLcased, "λ", "Λ")
					Case "mu":  		tempstr2 = IIF(IsLcased, "μ", "Μ")
					Case "nu":  		tempstr2 = IIF(IsLcased, "ν", "Ν")
					Case "xi":  		tempstr2 = IIF(IsLcased, "ξ", "Ξ")
					Case "omicron":  	tempstr2 = IIF(IsLcased, "ο", "Ο")
					Case "pi":  		tempstr2 = IIF(IsLcased, "π", "Π")
					Case "rho":  		tempstr2 = IIF(IsLcased, "ρ", "Ρ")
					Case "sigma":  		tempstr2 = IIF(IsLcased, "σ", "Σ")
					Case "tau":  		tempstr2 = IIF(IsLcased, "τ", "Τ")
					Case "upsilon":  	tempstr2 = IIF(IsLcased, "υ", "Υ")
					Case "phi":  		tempstr2 = IIF(IsLcased, "φ", "Φ")
					Case "chi":  		tempstr2 = IIF(IsLcased, "χ", "Χ")
					Case "psi":  		tempstr2 = IIF(IsLcased, "ψ", "Ψ")
					Case "omega":  		tempstr2 = IIF(IsLcased, "ω", "Ω")
					Case "prime":  		tempstr2 = IIF(IsLcased, "′", "″")
						
					Case "sigmaf": 		tempstr2 = "ς"
					Case "thetasym":  	tempstr2 = "ϑ"
					Case "upsih":  		tempstr2 = "ϒ"
					Case "piv":  		tempstr2 = "ϖ"
					Case "ensp":  		tempstr2 = " "
					Case "emsp":  		tempstr2 = " "
					Case "thinsp":  	tempstr2 = " "
					Case "ndash":  		tempstr2 = "–"
					Case "mdash":  		tempstr2 = "—"
					Case "horbar":  	tempstr2 = "―"
					Case "lsquo":  		tempstr2 = "‘"
					Case "rsquo":  		tempstr2 = "’"
					Case "sbquo":  		tempstr2 = "‚"
					Case "ldquo":  		tempstr2 = "“"
					Case "rdquo":  		tempstr2 = "”"
					Case "bdquo":  		tempstr2 = "„"
					Case "bull":  		tempstr2 = "•"
					Case "hellip":  	tempstr2 = "…"
					Case "permil":  	tempstr2 = "‰"
					Case "lsaquo":  	tempstr2 = "‹"
					Case "rsaquo":  	tempstr2 = "›"
					Case "oline":  		tempstr2 = "‾"
					Case "frasl":  		tempstr2 = "⁄"
					Case "euro":  		tempstr2 = "€"
					Case "image":  		tempstr2 = "ℑ"
					Case "weierp":  	tempstr2 = "℘"
					Case "real":  		tempstr2 = "ℜ"
					Case "trade":  		tempstr2 = "™"
					Case "alefsym":  	tempstr2 = "ℵ"
						
					Case "larr":  		tempstr2 = IIF(IsLcased, "←", "⇐")
					Case "uarr":  		tempstr2 = IIF(IsLcased, "↑", "⇑")
					Case "rarr":  		tempstr2 = IIF(IsLcased, "→", "⇒")
					Case "darr":  		tempstr2 = IIF(IsLcased, "↓", "⇓")
					Case "harr":  		tempstr2 = IIF(IsLcased, "↔", "⇔")
					Case "crarr":  		tempstr2 = "↵"
						
					Case "forall":  	tempstr2 = "∀"
					Case "part":  		tempstr2 = "∂"
					Case "exist":  		tempstr2 = "∃"
					Case "empty":  		tempstr2 = "∅"
					Case "nabla":  		tempstr2 = "∇"
					Case "isin":  		tempstr2 = "∈"
					Case "notin":  		tempstr2 = "∉"
					Case "ni":  		tempstr2 = "∋"
					Case "prod": 		tempstr2 = "∏"
					Case "sum":  		tempstr2 = "∑"
					Case "minus":  		tempstr2 = "-"
					Case "lowast":  	tempstr2 = "∗"
					Case "radic":  		tempstr2 = "√"
					Case "prop":  		tempstr2 = "∝"
					Case "infin":  		tempstr2 = "∞"
					Case "ang":  		tempstr2 = "∠"
					Case "and":  		tempstr2 = "∧"
					Case "or":  		tempstr2 = "∨"
					Case "cap":  		tempstr2 = "∩"
					Case "cup":  		tempstr2 = "∪"
					Case "int":  		tempstr2 = "∫"
					Case "there4":  	tempstr2 = "∴"'braniac!?
					Case "sim":  		tempstr2 = "~"
					Case "cong":  		tempstr2 = "≅"
					Case "asymp":  		tempstr2 = "≈"
					Case "ne":  		tempstr2 = "≠"
					Case "equiv": 		tempstr2 = "≡"
					Case "le":  		tempstr2 = "≤"
					Case "ge":  		tempstr2 = "≥"
					Case "sub":  		tempstr2 = "⊂"
					Case "sup":  		tempstr2 = "⊃"
					Case "nsub":  		tempstr2 = "⊄"
					Case "sube":  		tempstr2 = "⊆"
					Case "supe":  		tempstr2 = "⊇"
					Case "oplus":  		tempstr2 = "⊕"
					Case "otimes":  	tempstr2 = "⊗"
					Case "perp":  		tempstr2 = "⊥"
					Case "sdot":  		tempstr2 = "·"
					Case "lceil":  		tempstr2 = "⌈"
					Case "rceil":  		tempstr2 = "⌉"
					Case "lfloor":  	tempstr2 = "⌊"
					Case "rfloor":  	tempstr2 = "⌋"
					Case "lang":  		tempstr2 = "〈"
					Case "rang":  		tempstr2 = "〉"
					Case "loz":  		tempstr2 = "◊"
					Case "spades":  	tempstr2 = "♠"
					Case "clubs":  		tempstr2 = "♣"
					Case "hearts":  	tempstr2 = "♥"
					Case "diams":  		tempstr2 = "♦"
				End Select
			Else 
				tempstr2 = Chr(Value)
			End If
			If tempstr2.Length > 0 Then Text = Text.substring2(0,Index) & tempstr2 & Text.SubString(Index+tempstr.Length+2)
			Index = Text.IndexOf2("&", Index+1)
		End If
	Loop
	Return Text 
End Sub

'Case insensitive replace 
public Sub Replace(Text As String, Search As String, ReplaceWith As String) As String 
	Search = Search.ToLowerCase
	Dim Lower As String = Text.ToLowerCase, Index As Int = Lower.IndexOf(Search)
	Do While Index>-1
		Text = Text.substring2(0,Index) & ReplaceWith & Text.SubString(Index+Search.Length)
		Lower = Lower.substring2(0,Index) & ReplaceWith & Lower.SubString(Index+Search.Length)
		Index = Lower.IndexOf(Search)
	Loop
	Return Text
End Sub

private Sub Instr(Text As String, TextToFind As String, Start As Int) As Int
	If Start = -1 Then Return -1 
   	Return Text.IndexOf2(TextToFind,Start)
End Sub
private Sub Left(Text As String, Length As Long)As String 
   	If Length>Text.Length Then Length=Text.Length 
   	Return Text.SubString2(0, Length)
End Sub
private Sub Right(Text As String, Length As Long) As String
   	If Length>Text.Length Then Length=Text.Length 
   	Return Text.SubString(Text.Length-Length)
End Sub
private Sub Mid(Text As String, Start As Int, Length As Int) As String 
   	If Length>0 And Start>-1 And Start< Text.Length Then Return Text.SubString2(Start,Start+Length)
   	Return ""
End Sub


Sub MakeHTMLColor(Color As Int) As String 
	Dim A As Int = GetARGB(Color, 0), R As Int = GetARGB(Color, 1), G As Int = GetARGB(Color, 2), B As Int = GetARGB(Color, 3)
	If A = 255 Then Return "#" & Hex(R) & Hex(G) & Hex(B)
	Return "#" & Hex(A) & Hex(R) & Hex(G) & Hex(B)
End Sub 

Sub Hex(Number As Int) As String 
	Dim Temp As Int
	Temp = Floor(Number / 16)
	Return ToHex(Temp) & ToHex(Number - Temp*16)
End Sub
Sub ToHex(Number As Int) As String 
	If Number < 10 Then 
		Return Number 
	Else
		Return Chr(Number-10+ Asc("A"))
	End If
End Sub
'Channel: 0=a, 1=r, 2=g, 3=b
Sub GetARGB(Color As Int, Channel As Int) As Int
    Select Case Channel
    	Case 1: Return Bit.UnsignedShiftRight(Bit.And(Color, 0xff0000), 16)'R
    	Case 2: Return Bit.UnsignedShiftRight(Bit.And(Color, 0xff00), 8)'G
    	Case 3: Return Bit.And(Color, 0xff)'B
    End Select
	Return Bit.UnsignedShiftRight(Bit.And(Color, 0xff000000), 24)'A
End Sub



Sub TextWidthOrHeightAtHeight(Font As Typeface, Text As String, theFontSize As Int, IsWidth As Boolean)As Int 
	Dim tempstr() As String, Height As Int,Temp As Int, CRLFspace As Int=15, Width As Int 
	If Text<>Null Then
		If Text.Contains(CRLF) Then
			tempstr = Regex.Split(CRLF,Text)
			For Temp = 0 To tempstr.Length -1
				If IsWidth Then 
					Width=Max(Width, BG.MeasureStringWidth(tempstr(Temp),Font,Height))
				Else 
					Height=Height+BG.MeasureStringHeight(tempstr(Temp),Font,theFontSize)+CRLFspace
				End If 
			Next
			If IsWidth Then Return Width
			Return Height-CRLFspace
		End If 
		If IsWidth Then Return BG.MeasureStringWidth(Text,Font,Height)
		Return BG.MeasureStringHeight(Text,Font,theFontSize)
	End If
	Return 0
End Sub



Sub GetTextLimitedHeight(DesiredHeight As Int, DesiredWidth As Int, Text As String, theTypeface As Typeface) As Int
	Return Min(GetTextHeight(DesiredHeight,Text,theTypeface), GetTextHeight(-DesiredWidth,Text,theTypeface))
End Sub
'A negative DesiredHeight will act as the desired width instead
Sub GetTextHeight(DesiredHeight As Int, Text As String, theTypeface As Typeface ) As Int 
	Dim Temp As Int,CurrentHeight As Int 
	If theTypeface.IsInitialized And Text.Trim.Length>0 Then
		Do Until Temp >=  Abs(DesiredHeight)
			CurrentHeight=CurrentHeight+1
			If DesiredHeight>0 Then
				Temp = BG.MeasureStringHeight(Text, theTypeface, CurrentHeight)
			Else
				Temp = BG.MeasureStringWidth(Text, theTypeface, CurrentHeight)
			End If
		Loop
		If Temp>=Abs(DesiredHeight) Then CurrentHeight=CurrentHeight-1
	End If
	Return CurrentHeight
End Sub





'measure width of "&NBSP;" and " ", count occurences of "&NBSP;" and convert the widths between the 2
Sub CutTextAtWidth(Text As String,  theTypeface As Typeface, TextSize As Int, Width As Int, CutUpFirstWord As Boolean) As Int 
	Dim Temp As Int, temp2 As Int, cWidth As Int, cLen As Int, tempstr() As String, tempstr2 As String, SpaceWidth As Int'use HTMLentities after splitting
	If Text.Length>0 Then
		Temp = BG.MeasureStringWidth(Text.Replace("&NBSP;", " "), theTypeface,TextSize)
		If Temp> Width Then
			tempstr = Regex.Split(" ", Text)
			SpaceWidth = BG.MeasureStringWidth(" ", theTypeface,TextSize)
			For Temp = 0 To tempstr.Length-1
				tempstr2 = tempstr(Temp).Replace("&NBSP;", " ")
				temp2 = BG.MeasureStringWidth(tempstr2, theTypeface, TextSize)
				If Temp = 0 And temp2 > Width Then 
					If Not(CutUpFirstWord) Then Return 0
					For Temp = 1 To tempstr2.Length - 1
						Text = Mid(tempstr2, Temp, 1)
						temp2 = BG.MeasureStringWidth(Text, theTypeface, TextSize)
						If temp2 + cWidth > Width Then Return cLen 
						cWidth = cWidth + temp2 
						If Text = " " Then 
							cLen = cLen + 6
						Else 
							cLen = cLen + 1	
						End If
					Next
					Temp = 0
				End If
				If Temp > 0 Then temp2 = temp2 + SpaceWidth
				If temp2 + cWidth <= Width Then 
					cWidth = temp2 + cWidth
					cLen = cLen + tempstr(Temp).Length
					If Temp > 0 Then cLen = cLen + 1
				Else 
					Return cLen 
				End If
			Next
		End If
	End If
	Return Text.Length
End Sub
Sub TextWrap(Font As Typeface, TextSize As Int, Text As String, MaxWidth As Int) As String
	Dim tempstr() As String,Temp As Int , WidthofWord As Int ,WidthofLine As Int , tempstr2 As StringBuilder ,WidthofSpace As Int 
	If TextWidthAtHeight(Font,Text,TextSize) <= MaxWidth Then
		Return Text
	Else
		tempstr2.Initialize
		If Text.Contains(CRLF) Then
			tempstr = Regex.Split(CRLF, Text.Trim)
			For Temp = 0 To tempstr.Length-1
				If tempstr(Temp).Trim.Length>0 Then
					tempstr2.Append( TextWrap(Font, TextSize, tempstr(Temp), MaxWidth))
					If Temp < tempstr.Length-1 Then tempstr2.Append(CRLF)
				End If
			Next
		Else
			tempstr = Regex.Split(" ", Text)'(\b[^\s]+\b)
			WidthofSpace=TextWidthAtHeight(Font, " ", TextSize)
			For Temp = 0 To tempstr.Length-1
				WidthofWord=TextWidthAtHeight(Font, tempstr(Temp), TextSize)
				If WidthofLine + WidthofWord > MaxWidth Then 
					tempstr2.Append (" " & CRLF)
					If WidthofWord>WidthofLine Then
						tempstr2.Append(SplitWord(Font, TextSize, tempstr(Temp),MaxWidth,True) & " " & CRLF)
						WidthofLine=0
					Else
						tempstr2.Append(tempstr(Temp) & " ")
						WidthofLine=WidthofWord + WidthofSpace
					End If
				Else
					tempstr2.Append(tempstr(Temp) & " ")
					WidthofLine=WidthofLine+WidthofWord + WidthofSpace
				End If
			Next
		End If
		Return tempstr2.ToString 
	End If
End Sub
Sub TextWidthAtHeight(Font As Typeface, Text As String, Size As Int) As Int 
	Return TextWidthOrHeightAtHeight(Font, Text, Size, True)
End Sub
Sub SplitWord(Font As Typeface, TextSize As Int, Text As String, MaxWidth As Int, DoAppend As Boolean ) As String
	Dim Temp As Int, tempstr As StringBuilder , WidthofLine As Int ,WidthofChar As Int ,tempstr2 As String ,WidthofDash As Int
	tempstr.Initialize 
	WidthofDash=TextWidthAtHeight(Font,"-",TextSize)
	WidthofLine=WidthofDash
	For Temp = 0 To Text.Length-1
		tempstr2=Mid(Text,Temp,1)
		WidthofChar = TextWidthAtHeight(Font,tempstr2,TextSize)
		If WidthofLine+WidthofChar>MaxWidth Then 
			If DoAppend Then tempstr.Append("- " & CRLF & tempstr2 ) Else tempstr.Append("-")
			WidthofLine=WidthofDash
		Else
			tempstr.Append(tempstr2)
		End If
		WidthofLine=WidthofLine+WidthofChar
	Next
	Return tempstr.ToString 
End Sub

private Sub NullList As List 
	Dim RET As List 
	RET.Initialize
	Return RET 
End Sub
public Sub TestTag(HTML As String)
	Dim Parse As Map = ParseTag(HTML), theSplitHTML As List = SplitHTML(HTML)
	Log("SPLIT: " & HTML)
	For temp = 0 To theSplitHTML.Size-1
		Log(temp & ": " & theSplitHTML.Get(temp))
	Next
	If Parse.IsInitialized Then 
		Log("PARSE: " & HTML)
		For temp = 0 To Parse.Size-1
			Log(temp & ": " & Parse.GetKeyAt(temp) & " - " & Parse.GetValueAt(temp) )
		Next
	Else 
		LogColor("PARSE FAILED AT " & FailedOn & " (" & theSplitHTML.Get(FailedOn)  & "): " & HTML, Colors.Red)
	End If 
End Sub

public Sub LoadCSS(Dir As String, Filename As String)  
	Dim tempstr As String = File.ReadString(Dir, Filename), temp As Int = Instr(tempstr, "/*", 0), temp2 As Int
	Filename = File.Combine(Dir,Filename).ToLowerCase
	Do While temp > -1
		temp2 = Instr(tempstr, "*/", temp)
		If temp2 = -1 Then 
			tempstr = Left(tempstr, temp)
			temp = -1
		Else 	
			tempstr = Left(tempstr, temp) & Right(tempstr, tempstr.Length-temp2-2)
			temp = Instr(tempstr, "/*", temp2)
		End If 
	Loop
	temp = 1
	temp2= 1
	Do While temp > -1 And temp2 > -1 
		temp = Instr(tempstr, "{", 0)
		temp2 = Instr(tempstr, "}", temp)
		If temp2 > temp Then tempstr = LoadCSSpart(tempstr, temp, temp2, Filename)
	Loop
	
	Dim Font As TextInfo = LoadDefaultTextParameters 
	If ProcessCSS(Font, "body, html", NullList) Then SaveTextParametersToDefault(Font)
End Sub
private Sub ProcessCSS(Font As TextInfo, Selector As String, Hierarchy As List) As Boolean
	Dim temp As Int, temp2 As Int, RET As Boolean, CSSi As CSSinfo, Selectors() As String = Regex.Split(",", Selector), Key As String, Value As String 
	'Log("Searching for selector: " & Selector) 
	For temp = 0 To Selectors.Length-1 
		'Selector = Selectors(temp)
		Selectors(temp) = ReplaceMultiple(Selectors(temp).ToLowerCase.Trim, "  ", " ")
		'Log("BEFORE: " & Selector & " AFTER: " & Selectors(temp))
	Next 
	For temp = 0 To CSS.Size-1
		CSSi = CSS.Get(temp)
		If SelectorMatch(Selectors, CSSi, Hierarchy) > -1 Then
			'Log("Processing CSS " & temp & ": " & CSStoText(CSSi))
			For temp2 = 0 To CSSi.Data.Size-1
				Key = CSSi.Data.GetKeyAt(temp2)
				Value = CSSi.Data.GetValueAt(temp2)
				Select Case Key
					Case "background-color": 	Key = "bgcolor"
					Case "font-size": 			Key = "size"
					Case "font-style":			Key = "style"
					Case "content":				Key = "text"
					Case "font-family":			Key = "font"
						
					Case "line-height":			If IsNumber(Value) Then LineHeight = Value 
				End Select
				'Log("KEY: " & Selector & " TEXTPARAM: " & Key & " VALUE: " & Value)
				If SetTextParameter(Font, Key, Value) Then RET = True 
			Next
		End If
	Next
	Return RET
End Sub
private Sub loglist(Data As List, Name As String ) 
	Log("LIST: " & Name & " ITEMS: " & Data.Size)
	For temp = 0 To Data.Size-1
		Log(temp & ": " & Data.Get(temp))
	Next
	Log("--------------------------------------")
End Sub
private Sub SelectorMatch(Selectors() As String, CSSi As CSSinfo, Hierarchy As List) As Int 
	Dim temp As Int, temp2 As Int
	For temp = 0 To Selectors.Length-1
		temp2 = CSSi.Selectors.IndexOf(Selectors(temp))
		If temp2 > -1 Then Return temp2 
		temp2 = CSSi.Selectors.IndexOf("*")
		If temp2 > -1 Then Return temp2 
		
		For temp2 = 0 To CSSi.Selectors.Size - 1 
			If IsCSScomplex(CSSi.Selectors.Get(temp2)) Then 
				Log("ATTEMPT TO MATCH: '" & CSSi.Selectors.Get(temp2) & "' AGAINST ")
				loglist(Hierarchy, "Hierarchy")
			End If 
		Next
	Next
	Return -1 
End Sub
private Sub CSStoText(CSSi As CSSinfo) As String 
	Dim tempstr As StringBuilder, temp As Int 
	tempstr.Initialize
	For temp = 0 To CSSi.Selectors.Size-1
		If temp > 0 Then tempstr.Append(", ")
		tempstr.Append(CSSi.Selectors.Get(temp))
	Next
	tempstr.Append(" {")
	For temp = 0 To CSSi.Data.Size-1
		tempstr.Append(CRLF & "    " & CSSi.Data.GetKeyAt(temp) & ": " & CSSi.Data.GetValueAt(temp) & ";")
	Next 
	tempstr.Append(CRLF & "}")
	Return tempstr.ToString
End Sub
Private Sub LoadCSSpart(Text As String, LeftStart As Int, RightEnd As Int, Filename As String) As String 
	If LeftStart = -1 Then LeftStart = Instr(Text, "{", 0)
	If RightEnd = -1 Then RightEnd = Instr(Text, "}", LeftStart)
	Dim Selector As String = Left(Text, LeftStart).ToLowerCase.Trim, ToParse As String = Mid(Text, LeftStart+1, RightEnd-LeftStart-1).Replace(CRLF, ""), tempstr() As String, CSSi As CSSinfo, tempstr2() As String 
	CSSi.Initialize
	CSSi.Filename = Filename
	CSSi.Selectors.Initialize
	CSSi.Data.Initialize
	tempstr = Regex.Split(",", Selector)
	For LeftStart = 0 To tempstr.Length-1
		CSSi.Selectors.Add(ReplaceMultiple(tempstr(LeftStart).ToLowerCase.Trim, "  ", " "))
	Next
	tempstr = Regex.Split(";", ToParse)
	For LeftStart = 0 To tempstr.Length-1
		tempstr2 = Regex.Split(":", tempstr(LeftStart))
		If tempstr2.Length > 0 Then 
			tempstr2(0)= tempstr2(0).ToLowerCase.Trim
			If tempstr2(0).Length > 0 Then 
				If tempstr2.Length = 1 Then 
					CSSi.Data.Put(tempstr2(0), True)
				else if tempstr2.Length = 2 Then 
					tempstr2(1) = RemoveFromQuotes(tempstr2(1)).Trim
					CSSi.Data.Put(tempstr2(0), tempstr2(1))
				End If
			End If 
		End If 
	Next 
	'Log(CSStoText(CSSi))
	CSS.Add(CSSi)
	Return Right(Text, Text.Length-RightEnd-1)
End Sub
private Sub ClassToCSS(TagName As String, Classes As String, ID As String) As String 
	Dim tempstr() As String = Regex.Split(" ", ReplaceMultiple(Classes.Trim, "  ", " ")), temp As Int, tempstr2 As StringBuilder
	tempstr2.Initialize
	tempstr2.Append(TagName)
	If tempstr.Length > 0 Then 
		For temp = 0 To tempstr.Length-1 
			tempstr2.Append(", ." & tempstr(temp).Trim.ToLowerCase)
		Next
	End If 
	If ID.Length > 0 Then tempstr2.Append(", #" & ID.Trim.ToLowerCase)
	Return tempstr2.ToString
End Sub
public Sub ReplaceMultiple(Text As String, TextToRemove As String, TextToReplaceItWith As String) As String 
	Do While Instr(Text, TextToRemove, 0) > -1 
		Text = Text.Replace(TextToRemove, TextToReplaceItWith)
	Loop
	Return Text 
End Sub
private Sub IsInQuotes(Text As String) As Boolean 
	If Text.Length>1 Then 
		If Left(Text, 1) = vbQuote And Right(Text,1) = vbQuote Then Return True 
		If Left(Text, 1) = "'" And Right(Text,1) = "'" Then Return True 
	End If
	Return False 
End Sub
private Sub RemoveFromQuotes(Text As String) As String 
	If IsInQuotes(Text) Then Text = Mid(Text, 1, Text.Length -2)
	Return Text
End Sub